/*********************************************
 * 
 * Copyright (C) 1990-2014 by IBM.
 *  All Rights Reserved.
 *
 *  N O T I C E
 *
 *  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY IBM.
 *  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
 * *********************************************
 * 
 * 
 * IMPORTANT:
 * =========
 * This code is part of ARMOR3 Research Asset. It cannot be copied for any other use
 * except ARMOR3 project
 * Please contact ARMOR3 Team for any questions
 *
 *
 *
 * OPL 12.6 Model
 * Author: Abhishek Raman				
 *********************************************/
execute {  
	writeln("Start time : ",  new Date());
}; 

// Input Data =====================================================================================
	tuple T_PS_Scenario { 
		string asset_class_id;
	};
	{T_PS_Scenario} ST_PS_Scenario = ...;
	
	tuple T_PS_Execution_Parameters {
	  	int analysis_duration;
	  	int time_bucket;
	  	int analysis_year;
	};
	{T_PS_Execution_Parameters} ST_PS_Execution_Parameters = ...; 
	/*
	execute OutputToCSVStart {  
		var ofile = new IloOplOutputFile(".\\log\\assetScoreCalculationStarted.csv");
		ofile.writeln(ST_PS_Execution_Parameters);
		ofile.writeln("Start time : ",  new Date());
		ofile.close();    	
	};
	*/
	tuple T_Asset_Class { 
		string asset_class_id;
		string asset_class_name;
	};
	{T_Asset_Class} ST_Asset_Class = ...;
		
	tuple T_Asset_Id {
	  	string asset_id;
	  	string asset_class_id;
	}; 
	{T_Asset_Id} ST_Asset_Id = ...;
	
	tuple T_PS_Asset_Class_Filter {
	  	string asset_class_id;
	  	int factor_id;
	  	string index_type;
	  	int sequence_id;
	  	float from_range;
	  	float to_range;
	  	string string_value;
	  	int int_value;
  	};	  	
	{T_PS_Asset_Class_Filter} ST_PS_Asset_Class_Filter = ...;
	
	tuple T_AssetMappings {
	  	string asset_id;
	  	string asset_class_name;
	  	string app_asset_id;
	  	string location_id;
	  	string location_description;
	  	string street_name;
	};
	{T_AssetMappings} ST_AssetMappings = ...;
	
	tuple T_PS_Driver { 
		int driver_id; 
		string driver_name;
		string driver_nescription;
	};	
	{T_PS_Driver} ST_PS_Driver = ...;
		
	tuple T_PS_Factor { 
		int factor_id;
		string factor_name;
		string factor_description;
	};	
	{T_PS_Factor} ST_PS_Factor = ...; 
		
	tuple T_PS_Asset_Factor {
	  	string asset_id;
	  	int factor_id;
	  	string factor_value;
	  	int time;
	};
	{T_PS_Asset_Factor} ST_PS_Asset_Factor = ...;
	
	
	tuple T_PS_Asset_X_Driver { 
		string asset_class_id;
		int driver_id;
		int driver_index;
	};
	{T_PS_Asset_X_Driver} ST_PS_Asset_X_Driver = ...;
	
	tuple T_PS_Driver_X_Factor { 
		string asset_class_id;
		int driver_id;
		int factor_id;
		int factor_index;
		string default_value;
	};
	{T_PS_Driver_X_Factor} ST_PS_Driver_X_Factor = ...;
	
	tuple T_PS_Factor_Index {
	  	string asset_class_id;
	  	int driver_id;
	  	int factor_id;
	  	int index_sequence_id;
	  	string index_type;
	  	int from_range;
	  	int to_range;
	  	string string_value;
	  	int int_value;
	  	int index_value;
	};  
	{T_PS_Factor_Index} ST_PS_Factor_Index = ...; 
	/*
	{T_PS_Factor_Index} ST_PS_Factor_IndexNorm; 
	execute Calc_ST_Factor_IndexNorm {
		for(var fi in ST_PS_Factor_Index) { 
			if(fi.index_type=="Range" && fi.from_range==0) { 
				ST_PS_Factor_IndexNorm.add(
					fi.asset_class_id,
					fi.driver_id,
					fi.factor_id,
					fi.index_sequence_id,
					fi.index_type,
					-1,
					fi.to_range,
					fi.string_value,
					fi.int_value,
					fi.index_value);
 			} else { 
 				ST_PS_Factor_IndexNorm.add(fi);
  			} 						
		}		
 	}	  
	*/
	tuple T_PS_Degradation {
	  	string asset_class_id;
	  	int factor_id;
	  	int age;
	  	string description;
	  	float cumulative_degradation;
	};    	
	sorted {T_PS_Degradation} ST_PS_Degradation = ...;
	
	tuple T_PS_Asset_X_Treatment {
	  	string asset_class_id;
	  	int treatment_id;
	  	string unit;
	  	float unit_cost;
	  	int service_life_extension;
	  	int service_life_improvement;
	  	string description;
	  	string treatment_name;
	  	string treatment_description;
  	};
  	{T_PS_Asset_X_Treatment} ST_PS_Asset_X_Treatment = ...;
  	
  	tuple T_PS_Asset_Performance_X_Treatment {
	  	string asset_class_id;
	  	int treatment_id;	  
	  	int driver_id;
	  	int from_range;
	  	int to_range;
	  	string exclusion_factor_based;
	  	string exclusion_description;
	  	string exclusion_location_based;
  	};
  	{T_PS_Asset_Performance_X_Treatment} ST_PS_Asset_Performance_X_Treatment = ...;
  		
  	tuple T_PS_Treatment_Filter { 
  		string asset_class_id;
  		int treatment_id;
  		int driver_id;
  		int factor_id;
  		int filter_id;
  		int sequence_id;
  		string index_type;
  		int from_range;
  		int to_range;
  		string string_value;
  		int int_value;
  		string filter_name;
  		string filter_description;
  	};  			
  	{T_PS_Treatment_Filter} ST_PS_Treatment_Filter = ...;	
  	
  	tuple T_PS_Factor_Id_Age { 
		int factor_id;
	};
	{T_PS_Factor_Id_Age} ST_PS_Factor_Id_Age = ...;	
	
	tuple T_PS_Factor_Id_Length { 
		int factor_id;
	};
	{T_PS_Factor_Id_Length} ST_PS_Factor_Id_Length = ...;	  		
// ================================================================================================


// INTERNAL DATA ==================================================================================
	int P_fromYear = min(ep in ST_PS_Execution_Parameters) ep.analysis_year;
	int P_timeBucket = min(ep in ST_PS_Execution_Parameters) ep.time_bucket;
	int P_toYear = P_fromYear + min(ep in ST_PS_Execution_Parameters) ep.analysis_duration;	
	string P_assetClassId;
	execute{
		for (var ep in ST_PS_Scenario){
			P_assetClassId = ep.asset_class_id;
		}
	}
	int P_assetAgeFactorIndex = min(fi in ST_PS_Factor_Id_Age) fi.factor_id; //2;
	int P_assetLengthFactorIndex = min(fi in ST_PS_Factor_Id_Length) fi.factor_id; //9;
	{int} S_Driver_Id_In = {f.driver_id | f in ST_PS_Factor_Index}; 
	
	// Factor ids used in factor index calculation - only those will have score
	{int} S_Package_Index_In =  {f.factor_id | f in ST_PS_Driver_X_Factor}; 
	{int} S_Factor_Id_In = {f.factor_id | f in ST_PS_Factor_Index} diff ( {f.factor_id | f in ST_PS_Factor_Index} diff S_Package_Index_In );
	{int} S_Factor_Id_TimeSeries = {af.factor_id | af in ST_PS_Asset_Factor, f in S_Factor_Id_In : f==af.factor_id && af.time!=0};
	{int} S_Factor_Id_Degrading = {d.factor_id | d in ST_PS_Degradation, f in S_Factor_Id_In : f==d.factor_id};
	{int} S_Factor_Id_NonDegrading = S_Factor_Id_In diff S_Factor_Id_Degrading diff S_Factor_Id_TimeSeries;	
	
	// Factor ids used in asset class filter 
	{int} S_Factor_Id_by_Filter = {f.factor_id | f in ST_PS_Asset_Class_Filter};
	{int} S_Factor_Id_by_TreatmentFilter = {f.factor_id | f in ST_PS_Treatment_Filter};
	// All required factor ids due to: factor score + age + length + asset class filter
	{int} S_Factor_Id_All = S_Factor_Id_In union {P_assetAgeFactorIndex} union {P_assetLengthFactorIndex} union S_Factor_Id_by_Filter union S_Factor_Id_by_TreatmentFilter;

		
	// S_Asset_Id_All contains all asset ids in that asset class
	{string} S_Asset_Id_All = {a.asset_id | a in ST_Asset_Id, s in ST_PS_Scenario : a.asset_class_id==s.asset_class_id};
	// S_Asset_Id_In contains only the asset ids satisfying asset class filter
	{string} S_Asset_Id_In; 
	
	
	string P_assetFactor[S_Asset_Id_All][S_Factor_Id_All] = [
		a : [f : 
		af.factor_value]
		|
		af in ST_PS_Asset_Factor,
		a in S_Asset_Id_All,
		f in S_Factor_Id_All
		:
		af.asset_id==a
		&& af.factor_id==f
	];	
	
	//if no length property for current asset class, use 1 as default length 
	execute{
		if(P_assetLengthFactorIndex == 0){
			for (var asset_id in S_Asset_Id_All){
				P_assetFactor[asset_id][0] = "1";
			}
		}
	
	}
	
	// Asset Class Filter -------------------------------------------------------------------------
	/*
	execute CalcAssetClassFilter { 
		var isSatisfied;
		if(Opl.card(ST_PS_Asset_Class_Filter) > 0) { 
			// writeln("there is asset class filter");
			for(var a in S_Asset_Id_All) {
			  	isSatisfied = 1
		
			  	for(var acf in ST_PS_Asset_Class_Filter) { 
			   		if(acf.index_type=="String") { 
			   			if(P_assetFactor[a][acf.factor_id]!=acf.string_value) {
         					isSatisfied = 0;	
         				}			   			  
      				}
      				else if (acf.index_type=="Int") { 
      					if(Opl.round(Opl.floatValue(P_assetFactor[a][acf.factor_id]))!=acf.int_value) {
         					isSatisfied = 0;
         				}	
        			}
        			else if (acf.index_type=="Range"){
        			  	if(Opl.floatValue(P_assetFactor[a][acf.factor_id])<acf.from_range || Opl.floatValue(P_assetFactor[a][acf.factor_id])>=acf.to_range) {
         					isSatisfied = 0;
         				}
           			}        			        							   		
			  		
			  		if(isSatisfied == 0) break;	
    			} // for(var acf in ST_PS_Asset_Class_Filter)			  		
  				
  				if(isSatisfied == 1) { 
			  		S_Asset_Id_In.add(a);
     			}
  				
   			} // for(var a in S_Asset_Id_All)			  
		} else {
			S_Asset_Id_In = S_Asset_Id_All;
		}				
	};	
	*/
	{string} S_Asset_Id_by_FilterFactor[f in S_Factor_Id_by_Filter] = {af.asset_id | a in S_Asset_Id_All, af in ST_PS_Asset_Factor: a==af.asset_id && af.factor_id==f}  ;
	{string} S_Asset_Id_In_by_Filter[ST_PS_Asset_Class_Filter]; 
	int P_Asset_Count_by_Filter[a in S_Asset_Id_All] = 0;
	
	execute CalcAssetClassFilterV2 { 
		var isSatisfied;
		if(Opl.card(ST_PS_Asset_Class_Filter) > 0) { 
			// writeln("there is asset class filter");
			for(var acf in ST_PS_Asset_Class_Filter) { 
				for(var a in S_Asset_Id_by_FilterFactor[acf.factor_id]) {
				  	isSatisfied=0;
			   		if(acf.index_type=="String") { 
			   			if(P_assetFactor[a][acf.factor_id]==acf.string_value) {
         					isSatisfied = 1;	
         				}			   			  
      				}
      				else if (acf.index_type=="Int") { 
      					if(Opl.round(Opl.floatValue(P_assetFactor[a][acf.factor_id]))==acf.int_value) {
         					isSatisfied = 1;
         				}	
        			}
        			else if (acf.index_type=="Range"){
        			  	if(Opl.floatValue(P_assetFactor[a][acf.factor_id])>=acf.from_range && Opl.floatValue(P_assetFactor[a][acf.factor_id])<acf.to_range) {
         					isSatisfied = 1;
         				}
           			} 
           			
           			if(isSatisfied == 1) { 
				  		S_Asset_Id_In_by_Filter[acf].add(a);
				  		P_Asset_Count_by_Filter[a] = P_Asset_Count_by_Filter[a] + 1;
	     			}       			        							   			
    			} // for(var a in S_Asset_Id_by_FilterFactor[acf.factor_id])			  				
	  			writeln(acf, " " , Opl.card(S_Asset_Id_In_by_Filter[acf]));	

	   		} // for(var acf in ST_PS_Asset_Class_Filter)				  
			
			for(var aa in S_Asset_Id_All) {
				if(P_Asset_Count_by_Filter[aa] == Opl.card(ST_PS_Asset_Class_Filter)) {
					S_Asset_Id_In.add(aa);
   				}
    		}
    		   									
		} else {
			S_Asset_Id_In = S_Asset_Id_All;
		}
					
	};	
	//---------------------------------------------------------------------------------------------
	
	sorted {int} S_Planning_Horizon ;
	execute CalcAnalysisYear { 
		var time = P_fromYear
		S_Planning_Horizon.add(time);
		while (time < P_toYear) {
			time = time + P_timeBucket;  
			S_Planning_Horizon.add(time);
	 	}
	 	// writeln(S_Planning_Horizon);	  
	};
	
	string P_assetFactor_statistical[S_Asset_Id_All][S_Factor_Id_All][S_Planning_Horizon] = [
		a : [f : [t: 
		af.factor_value]]
		|
		af in ST_PS_Asset_Factor,
		a in S_Asset_Id_All,
		f in S_Factor_Id_TimeSeries,
		t in S_Planning_Horizon
		:
		af.asset_id==a
		&& af.factor_id==f
		&& af.time==t
	];	
	
	{int} S_driverId = {d.driver_id | d in ST_PS_Driver};
	T_PS_Driver P_driverName[S_driverId] = [
		di
		: 
		d
		|
		di in S_driverId,
		d in ST_PS_Driver
		:
		d.driver_id==di
	];
	
	{int} S_factorId = {d.factor_id | d in ST_PS_Factor};
	T_PS_Factor P_factorName[S_factorId] = [
		fi
		: 
		f
		|
		fi in S_factorId,
		f in ST_PS_Factor
		:
		f.factor_id==fi
	];
	
	string P_driverFactorDefaultValue[S_Driver_Id_In][S_Factor_Id_In] = [
		di : [fi : df.default_value]
		|
		di in S_Driver_Id_In,
		fi in S_Factor_Id_In,
		df in ST_PS_Driver_X_Factor
		:
		df.driver_id==di 
		&& df.factor_id==fi
	];
	execute { P_driverFactorDefaultValue } ; 
	
	int P_driverFactorIndex[S_Driver_Id_In][S_Factor_Id_In] = [
		di : [fi : df.factor_index]
		|
		di in S_Driver_Id_In,
		fi in S_Factor_Id_In,
		df in ST_PS_Driver_X_Factor
		:
		df.driver_id==di 
		&& df.factor_id==fi
	];
	
	int P_driverIndex[S_Driver_Id_In] = [
		di: ad.driver_index
		|
		di in S_Driver_Id_In,
		ad in ST_PS_Asset_X_Driver
		:
		ad.driver_id==di
	];
	
	
	
	{int} S_Age = {d.age | d in ST_PS_Degradation};	
	
	// Degradation related calculations -----------------------------------------------------------
	// Statistical factors can not be degradation factors
	int P_isFactorDegrading[S_Factor_Id_All];
	execute{
		for (var fi in S_Factor_Id_All) { 
			P_isFactorDegrading[fi]=0;
		}
	}
	
	execute CalcFactorDegrading { 
	 	for(var fi in S_Factor_Id_All) { 
	 		for(var fid in S_Factor_Id_Degrading) {
	 		  	if(fi==fid) {
	 		  		P_isFactorDegrading[fi]=1;
	 		  		for (var sf in S_Factor_Id_TimeSeries){
	 		  			if(sf==fi){
	 		  					P_isFactorDegrading[fi]=0;
	 		  					break;
	 		  			}
	 		  		}
	 		  	}
	 		  	//else P_isFactorDegrading[fi]=0;
   			}
    	}   				 		 
	};
	
	int P_maxDegradatoinAge[S_Factor_Id_Degrading];
	int P_maxAge = 1000;
	execute Calc_maxDegradationAge {
		for(var df0 in S_Factor_Id_Degrading) { 
		  	P_maxDegradatoinAge[df0] = 0;
		  	for(var d0 in ST_PS_Degradation) {
		  		if(df0==d0.factor_id && d0.age > P_maxDegradatoinAge[df0]) {
	     			P_maxDegradatoinAge[df0] = d0.age;
	     		}           				  			    
	     	}	  		  
	  	}	
	}
	
	float P_Degradation[S_Factor_Id_Degrading][0..P_maxAge];
	execute Calc_P_Degradation {
	  	for(var f in S_Factor_Id_Degrading) {
	  		var flag = 0;
	  		for(var d1 in ST_PS_Degradation) {
	  			if (f == d1.factor_id && d1.age==0 ){
	  				flag = 1;
	  				P_Degradation[f][0] = Opl.round(100*d1.cumulative_degradation/100);
	  			}
	  		}
	  		if (flag == 0)
	  		{
	  			P_Degradation[f][0] = 0;
	  		}
	  	}
	  
	  	for(var d1 in ST_PS_Degradation) {
	  		/*
	  		* check if degradation factor is used in asset driver factor
	  		*/
	  		var isFactorDefined = 0;
	  		for (var adf in S_Factor_Id_Degrading) {
	  		  	if (adf == d1.factor_id ){
	  		  		isFactorDefined = 1;
	  		  		break;
	  		  	}
	  		}
	  		if (isFactorDefined == 1 ){
	  			var d2 = Opl.nextc(ST_PS_Degradation, d1)
	  			if(d1.factor_id==d2.factor_id && d1.age < d2.age) {
	  		  		var a = d1.age;
	  		  		while(a<=d2.age) {
    	 				P_Degradation[d1.factor_id][a] = Opl.round(
    	 												100*
    	 												(  d1.cumulative_degradation + (a-d1.age)*(d2.cumulative_degradation-d1.cumulative_degradation)/(d2.age-d1.age)  )
    	 												)/100;
    	 				a = a+1;
      				}    	 		
    	 		}	
	  		}
	  		  		
  		}	  	
 	}	 
 	execute Calc_P_DegradationMissing { 
 		for(var f in S_Factor_Id_Degrading) {
 		  	var maxDegAge = P_maxDegradatoinAge[f];
 		  	var a = maxDegAge+1;
 			while(a <= P_maxAge) { 
 			  	P_Degradation[f][a] = P_Degradation[f][maxDegAge];
 			  	a = a+1;
    		} 			  
   		} 		  	
	}	
	//---------------------------------------------------------------------------------------------
	
	
// ================================================================================================




// Factor Score Calculation =======================================================================
 
// Asset Factor Score Calculation for Non-Degrading Factors =======================================
	execute {  
		writeln("Start CalcFactorScoreNonDegrading : ",  new Date());
	};

	tuple T_Factor_Score_ND {
	  	string asset_id;
	  	int driver_id;
	  	int factor_id;
	  	string factor_value;
	  	int factor_score;
	};  	
	{T_Factor_Score_ND} ST_Factor_Score_ND;
	
	tuple T_Factor_Score_ND_Time {
	  	string asset_id;
	  	int driver_id;
	  	int factor_id;
	  	string factor_value;
	  	int factor_score;
	  	int time;
	};
	
	execute CalcFactorScoreNonDegrading { 
		
		for(var fnd in S_Factor_Id_NonDegrading) {
		  	// shift factor_index and asset_id loops, and break once comparison is satisfied
		  	
		  	for(var fi in ST_PS_Factor_Index) { 
		  		if(fi.factor_id==fnd) { 
		  		
		  			if(fi.index_type=="String") { // if index type is String ==========================
					 	for(var ai in S_Asset_Id_In) { 
				 			if(P_assetFactor[ai][fnd] == "") {
				 			  	if(P_driverFactorDefaultValue[fi.driver_id][fnd]==fi.string_value) {
				 					ST_Factor_Score_ND.add(ai,fi.driver_id,fnd,P_driverFactorDefaultValue[fi.driver_id][fnd],fi.index_value); 
	      						}			 				
				    		}else if (P_assetFactor[ai][fnd]==fi.string_value) {
				    			ST_Factor_Score_ND.add(ai,fi.driver_id,fnd,P_assetFactor[ai][fnd],fi.index_value);   	
				      		}    		   			  
				 		}	
	   				}	
	 				
	   				else if(fi.index_type=="Int") { // if index type is Int ================================
					 	for(var ai2 in S_Asset_Id_In) { 
				 			if(P_assetFactor[ai2][fnd] == "") {
				 				if(Opl.round(Opl.floatValue(P_driverFactorDefaultValue[fi.driver_id][fnd]))==fi.int_value) {
				 					ST_Factor_Score_ND.add(ai2,fi.driver_id,fnd,P_driverFactorDefaultValue[fi.driver_id][fnd],fi.index_value); 
	     						}			 			
				    		}else if (Opl.round(Opl.floatValue(P_assetFactor[ai2][fnd]))==fi.int_value) {
				    			ST_Factor_Score_ND.add(ai2,fi.driver_id,fnd,P_assetFactor[ai2][fnd],fi.index_value);   	
				      		}    		   			  
				 		}	
	   				}	
	   				
	   				else if(fi.index_type=="Range") { // if index type is Range ============================
					 	for(var ai3 in S_Asset_Id_In) { 
				 			if(P_assetFactor[ai3][fnd] == "") {
				 			  	if(Opl.floatValue(P_driverFactorDefaultValue[fi.driver_id][fnd])>=fi.from_range && Opl.floatValue(P_driverFactorDefaultValue[fi.driver_id][fnd])<fi.to_range) {
				 					ST_Factor_Score_ND.add(ai3,fi.driver_id,fnd,P_driverFactorDefaultValue[fi.driver_id][fnd],fi.index_value); 
	       						}			 					
				    		}else if (Opl.floatValue(P_assetFactor[ai3][fnd])>=fi.from_range && Opl.floatValue(P_assetFactor[ai3][fnd])<fi.to_range) {
				    			ST_Factor_Score_ND.add(ai3,fi.driver_id,fnd,P_assetFactor[ai3][fnd],fi.index_value);   	
				      		}    		   			  
				 		}	
	   				}			 	
	   			}		 		 	
	 		}		  
	 	}	 // for(var fnd in S_Factor_Id_NonDegrading)
	}
	

	{T_Factor_Score_ND_Time} ST_Factor_Score_ND_Time = {
	  	<
	  	fs.asset_id,
	  	fs.driver_id,
	  	fs.factor_id,
	  	fs.factor_value,
	  	fs.factor_score,
	  	t
	  	>|
	  	fs in ST_Factor_Score_ND,
	  	t in S_Planning_Horizon
	};  	

// ================================================================================================
	
	
	
	
// Asset Factor Score Calculation for Degrading Factors ===========================================
	execute {  
		writeln("Start CalcFactorScoreDegrading : ",  new Date());
	}; 
	
	tuple T_Factor_Score_D {
	  	string asset_id;
	  	int driver_id;
	  	int factor_id;
	  	string factor_value;
	  	int factor_score;
	  	int time;
	};  	
	{T_Factor_Score_D} ST_Factor_Score_D;
	
	execute CalcFactorScoreDegrading {
		var P_degradedFactorvalue;
		var P_degradedFactorvalueStr;
		var P_cumDegradation;
		var P_degradationAgeTo;
		var P_degradationAgeFrom;
		var P_addAge; 
		

		// use ST_PS_Factor_Index_D after year and asset ****************************************************************
		
		for(var fnd2 in S_Factor_Id_Degrading) {
			if(P_isFactorDegrading[fnd2]==0)
				break;
		  	for(var fi2 in ST_PS_Factor_Index) { 
		  		if(fi2.factor_id==fnd2) { 
		  		
		  			if(fi2.index_type=="Int") { // if index type is Int ================================
					 	for(var ai4 in S_Asset_Id_In) { 
					 		for(var t in S_Planning_Horizon) {
					 		  	P_addAge = t - P_fromYear;
					 		  	if(P_assetFactor[ai4][P_assetAgeFactorIndex] == ''){
					 				P_degradationAgeFrom = 0;
					 			}else{
					 				P_degradationAgeFrom = P_assetFactor[ai4][P_assetAgeFactorIndex];
					 			}
					 		  	P_degradationAgeTo = Opl.intValue(P_degradationAgeFrom) + P_addAge; 
					 		  	if (P_degradationAgeFrom==0 && P_addAge==0){
					 		  		P_cumDegradation = P_Degradation[fi2.factor_id][P_degradationAgeTo];
					 		  	}else{
					 		  		P_cumDegradation = ( P_Degradation[fi2.factor_id][P_degradationAgeTo] - P_Degradation[fi2.factor_id][P_degradationAgeFrom] );
					 		  	}
					 			if(P_assetFactor[ai4][fnd2] == "") {
					 			  	P_degradedFactorvalue = Opl.floatValue(P_driverFactorDefaultValue[fi2.driver_id][fnd2]) + P_cumDegradation; 	 							 			
					    		}else {
					    			P_degradedFactorvalue = Opl.floatValue(P_assetFactor[ai4][fnd2]) + P_cumDegradation;	 	
					      		} 
					      		
					      		if(P_degradedFactorvalue==fi2.int_value) {
					      		  	P_degradedFactorvalueStr = P_degradedFactorvalue + "";
					 				ST_Factor_Score_D.add(ai4,fi2.driver_id,fnd2,P_degradedFactorvalueStr,fi2.index_value,t); 
		     					}
	         				} // for(var t in S_Planning_Horizon)			      	   		   			  
				 		} // for(var ai4 in S_Asset_Id_In)
	   				} //if(fi2.index_type=="Int")
	   				
	   				else if(fi2.index_type=="Range") { // if index type is Int ================================
					 	for(var ai5 in S_Asset_Id_In) { 
					 		for(var t2 in S_Planning_Horizon) { 
					 			P_addAge = t2 - P_fromYear;
					 			if(P_assetFactor[ai5][P_assetAgeFactorIndex] == ''){
					 				P_degradationAgeFrom = "0";
					 			}else{
					 				P_degradationAgeFrom = P_assetFactor[ai5][P_assetAgeFactorIndex];
					 			}
					 			
					 			P_degradationAgeTo =  Opl.intValue(P_degradationAgeFrom) + P_addAge; 
					 			P_cumDegradation = ( P_Degradation[fi2.factor_id][P_degradationAgeTo] - P_Degradation[fi2.factor_id][P_degradationAgeFrom] );
					 			if (P_degradationAgeFrom==0 && P_addAge==0){
					 				P_cumDegradation = P_Degradation[fi2.factor_id][P_degradationAgeTo];
					 		  	}else{
					 		  		P_cumDegradation = ( P_Degradation[fi2.factor_id][P_degradationAgeTo] - P_Degradation[fi2.factor_id][P_degradationAgeFrom] );
					 		  	}					 			
					 			if(P_assetFactor[ai5][fnd2] == "") {
					 			  	P_degradedFactorvalue = Opl.floatValue(P_driverFactorDefaultValue[fi2.driver_id][fnd2]) + P_cumDegradation; 	 			
					    		}else {
					    			P_degradedFactorvalue = Opl.floatValue(P_assetFactor[ai5][fnd2]) + P_cumDegradation;		    				 	
					      		} 
	          							      		
					      		if(P_degradedFactorvalue>=fi2.from_range && P_degradedFactorvalue<fi2.to_range) {
					      		  	P_degradedFactorvalueStr = P_degradedFactorvalue + "";
					    			ST_Factor_Score_D.add(ai5,fi2.driver_id,fnd2,P_degradedFactorvalueStr,fi2.index_value,t2);
	         					}		
	         				} // for(var t2 in S_Planning_Horizon)			      	   		   			  
				 		} // for(var ai5 in S_Asset_Id_In)
	   				} //if(fi2.index_type=="Int")
	   				
	   				
	    		}  // if(fi2.factor_id==fnd2) 				
	  		} // for(var fi2 in ST_PS_Factor_Index)  	
	 	} // for(var fnd2 in S_Factor_Id_Degrading)
	 	
	}; // end Execute 
// ================================================================================================



// ================================================================================================
// Asset Factor Score Calculation for time series Factors ===========================================
	execute {  
		writeln("Start CalcFactorScoreStatistical : ",  new Date());
	}; 
	
	tuple T_Factor_Score_S {
	  	string asset_id;
	  	int driver_id;
	  	int factor_id;
	  	string factor_value;
	  	int factor_score;
	  	int time;
	};  	
	{T_Factor_Score_S} ST_Factor_Score_S;
	
	execute CalcFactorScoreStatistical {
		var P_statisticalFactorvalue;
		var P_statisticalFactorvalueStr;
		
		for(var fnd2 in S_Factor_Id_TimeSeries) {
		  	for(var fi2 in ST_PS_Factor_Index) { 
		  		if(fi2.factor_id==fnd2) { 
		  		
		  			if(fi2.index_type=="Int") { // if index type is Int ================================
					 	for(var ai4 in S_Asset_Id_In) { 
					 		for(var t in S_Planning_Horizon) {
					 			if(P_assetFactor_statistical[ai4][fnd2][t] == "" || P_assetFactor_statistical[ai4][fnd2][t] == null) {
					 			  	P_statisticalFactorvalue = Opl.floatValue(P_driverFactorDefaultValue[fi2.driver_id][fnd2]); 	 							 			
					    		}else {
					    			P_statisticalFactorvalue = Opl.floatValue(P_assetFactor[ai4][fnd2][t]);	 	
					      		} 
					      		
					      		if(P_statisticalFactorvalue==fi2.int_value) {
					      		  	P_statisticalFactorvalueStr = P_statisticalFactorvalue + "";
					 				ST_Factor_Score_S.add(ai4,fi2.driver_id,fnd2,P_statisticalFactorvalueStr,fi2.index_value,t); 
		     					}
	         				} // for(var t in S_Planning_Horizon)			      	   		   			  
				 		} // for(var ai4 in S_Asset_Id_In)
	   				} //if(fi2.index_type=="Int")
	   				
	   				else if(fi2.index_type=="Range") { // if index type is Int ================================
					 	for(var ai5 in S_Asset_Id_In) { 
					 		for(var t2 in S_Planning_Horizon) { 
					 			if(P_assetFactor_statistical[ai5][fnd2][t2] == "" || P_assetFactor_statistical[ai5][fnd2][t2] == null) {
					 			  	P_statisticalFactorvalue = Opl.floatValue(P_driverFactorDefaultValue[fi2.driver_id][fnd2]); 	 			
					    		}else {
					    			P_statisticalFactorvalue = Opl.floatValue(P_assetFactor_statistical[ai5][fnd2][t2]);		    				 	
					      		} 
	          							      		
					      		if(P_statisticalFactorvalue>=fi2.from_range && P_statisticalFactorvalue<fi2.to_range) {
					      		  	P_statisticalFactorvalueStr = P_statisticalFactorvalue + "";
					    			ST_Factor_Score_S.add(ai5,fi2.driver_id,fnd2,P_statisticalFactorvalueStr,fi2.index_value,t2);
	         					}		
	         				} // for(var t2 in S_Planning_Horizon)			      	   		   			  
				 		} // for(var ai5 in S_Asset_Id_In)
	   				} //if(fi2.index_type=="Int")
	   				
	   				
	    		}  // if(fi2.factor_id==fnd2) 				
	  		} // for(var fi2 in ST_PS_Factor_Index)  	
	 	} // for(var fnd2 in S_Factor_Id_Degrading)
	 	
	 	writeln("# of assets ", Opl.card(S_Asset_Id_In));
		writeln("# of asset factor scores ND ", Opl.card(ST_Factor_Score_ND));
		writeln("# of asset factor scores D ", Opl.card(ST_Factor_Score_D));	
		writeln("# of asset factor scores S ", Opl.card(ST_Factor_Score_S));	
	}; // end Execute 
// ================================================================================================


// ================================================================================================
// Reports ========================================================================================
// ================================================================================================
	
	// Asset Factor Score =========================================================================
	{T_Factor_Score_D} ST_Factor_Score_D_ND = ST_Factor_Score_ND_Time union ST_Factor_Score_D union ST_Factor_Score_S;
	
	tuple T_PS_Asset_Factor_Score {
	  	string asset_class_id;
	  	string asset_id;
	  	int driver_id;
	  	string driver_name;
	  	int factor_id;
	  	string factor_name;
	  	string factor_value;
	  	float factor_score;
	  	int factor_weight;
	  	float weighted_factor_score;
	  	string location_description;
	  	string street_name;
	  	string app_asset_id;
	  	int time;
	};  	
	
	{T_PS_Asset_Factor_Score} ST_PS_Asset_Factor_Score = {
	  	<
	  	P_assetClassId,
	  	afs.asset_id,
	  	afs.driver_id,
	  	P_driverName[afs.driver_id].driver_name,
	  	afs.factor_id,
	  	P_factorName[afs.factor_id].factor_name,
	  	afs.factor_value,
	  	afs.factor_score,
	  	P_driverFactorIndex[afs.driver_id][afs.factor_id],
	  	afs.factor_score*P_driverFactorIndex[afs.driver_id][afs.factor_id]/100,
	  	cam.location_description,
	  	cam.street_name,
	  	cam.app_asset_id,
	  	afs.time
	  	>|
	  	afs in ST_Factor_Score_D_ND,
	  	cam in ST_AssetMappings
  		:
  		afs.asset_id==cam.asset_id 
  	};	 	

	// Asset Driver Score =========================================================================
	tuple T_Asset_Driver_Score_In { 
		string asset_class_id;
	  	string asset_id;
	  	int driver_id;
	  	string driver_name;
	  	string location_description;
	  	string street_name;
	  	string app_asset_id;
	  	int time;
	};  
	{T_Asset_Driver_Score_In} ST_Asset_Driver_Score_In = { 
		<
		afs.asset_class_id,
		afs.asset_id,
		afs.driver_id,
		afs.driver_name,
		afs.location_description,
		afs.street_name,
		afs.app_asset_id,
		afs.time
		>|
		afs in ST_PS_Asset_Factor_Score	
	};		
	
	tuple T_PS_Asset_Driver_Score {
	  	string asset_class_id;
	  	string asset_id;
	  	int driver_id;
	  	string driver_name;
	  	float driver_score;
	  	int weight;
	  	float weight_driver_score;
	  	string location_description;
	  	string street_name;
	  	string app_asset_id;
	  	int time;
	};  	
	{T_PS_Asset_Driver_Score} ST_PS_Asset_Driver_Score = {
		<
		ads.asset_class_id,
		ads.asset_id,
		ads.driver_id,
		ads.driver_name,
		sum(afs in ST_PS_Asset_Factor_Score : afs.asset_id==ads.asset_id && afs.driver_id==ads.driver_id && afs.time==ads.time)afs.weighted_factor_score,
		P_driverIndex[ads.driver_id],
		sum(afs in ST_PS_Asset_Factor_Score : afs.asset_id==ads.asset_id && afs.driver_id==ads.driver_id && afs.time==ads.time)afs.weighted_factor_score*P_driverIndex[ads.driver_id]/100,
		ads.location_description,
		ads.street_name,
		ads.app_asset_id,
		ads.time
		>|
		ads in ST_Asset_Driver_Score_In 
 	};	  
	
	// Asset Score ================================================================================
	tuple T_Asset_Score_In { 
		string asset_class_id;
	  	string asset_id;
	  	string location_description;
	  	string street_name;
	  	string app_asset_id;
	  	int time;
	};  
	{T_Asset_Score_In} ST_Asset_Score_In = { 
		<
		ads.asset_class_id,
		ads.asset_id,
		ads.location_description,
		ads.street_name,
		ads.app_asset_id,
		ads.time
		>|
		ads in ST_Asset_Driver_Score_In	
	};		
	tuple T_PS_Asset_Score {
	  	key string asset_class_id;
	  	key string asset_id;
	  	float asset_score;
	  	string location_description;
	  	string street_name;
	  	string app_asset_id;
	  	key int time;
	};  	
	{T_PS_Asset_Score} ST_PS_Asset_Score = {
		<
		as.asset_class_id,
		as.asset_id,
		sum(ads in ST_PS_Asset_Driver_Score : ads.asset_id==as.asset_id && ads.time==as.time)ads.weight_driver_score,
		as.location_description,
		as.street_name,
		as.app_asset_id,
		as.time
		>|
		as in ST_Asset_Score_In 
 	};	  
 	
 	// Asset Class Score ==========================================================================
	{string} S_assetId_hasScore = {as.asset_id | as in ST_PS_Asset_Score};
	float P_totalLength = sum(ai in S_assetId_hasScore) floatValue(P_assetFactor[ai][P_assetLengthFactorIndex]);
	
	tuple T_PS_Asset_Class_Score { 
		string asset_class_id;
		string asset_class_name;
		float asset_class_score;
		int time;
	};
	{T_PS_Asset_Class_Score} ST_PS_Asset_Class_Score = { 
		<
		a.asset_class_id,
		a.asset_class_name,
		sum(as in ST_PS_Asset_Score : as.time==t) floatValue(P_assetFactor[as.asset_id][P_assetLengthFactorIndex])*as.asset_score/P_totalLength ,
		t
		>|
		a in ST_Asset_Class, 
		s in ST_PS_Scenario, 
		t in S_Planning_Horizon
		: a.asset_class_id==s.asset_class_id	
	};				 	
 	
 	
 	// Asset Prescription =========================================================================
 	tuple T_PS_Asset_Prescription_Pre {
	  	string asset_id;
	  	int driver_id;
	  	int treatment_id;	
	  	string location_description;
	  	int time;  
  	};
  	{T_PS_Asset_Prescription_Pre} ST_PS_Asset_Prescription_Pre;
 	
 	execute CalcAssetPrescriptionPre { 
 		for(var ads in ST_PS_Asset_Driver_Score) { 
 			for(var apt in ST_PS_Asset_Performance_X_Treatment) { 
				if(apt.driver_id==ads.driver_id) {
					if(ads.driver_score >= apt.from_range && ads.driver_score < apt.to_range) {
						ST_PS_Asset_Prescription_Pre.add(ads.asset_id, ads.driver_id, apt.treatment_id, ads.location_description, ads.time);
     				}					  
    			}				  		
  			}; //  for(var apt in ST_PS_Asset_Performance_X_Treatment)			
 		}; // for(var a in S_Asset_Id_In)
	}; 	
 	
 	{int} S_treatmentFilterId = {f.filter_id | f in ST_PS_Treatment_Filter}; 
 	
 	{T_PS_Asset_Prescription_Pre} ST_PS_Asset_Prescription_Filtered;
 	{T_PS_Asset_Prescription_Pre} ST_PS_Asset_Prescription_Filtered_Out;
 	execute CalcAssetPrescriptionFiltered {
 	  	var isExcluded;
 	  	var isExcludedByFilterId; // Requires any filter-id to be true for exclusion
 	  	var isExcludedBySubFilter; // Requires all sub-filters to be true for filter-id to be true
 		var P_addAge;
 		var P_degradationAgeFrom;
 		var P_degradationAgeTo;
 		var P_cumDegradation;
 		for(var ap in ST_PS_Asset_Prescription_Pre) { 
 			isExcluded = 0; 
 			
 			// If excluded by any Filter-id, then it is excluded
 			for(var tfi in S_treatmentFilterId) { 
 				isExcludedByFilterId = 0;
 				// If excluded by all Sub-filters, then it is ecluded by parent Filter-id
 				for(var tf in ST_PS_Treatment_Filter) {
 				  	if(tfi==tf.filter_id) { 
 				  		// if(tf.driver_id==ap.driver_id && tf.treatment_id==ap.treatment_id) { 
 				  		if(tf.treatment_id==ap.treatment_id) { 
	 				  		isExcludedBySubFilter = 0;
	 				  		
	 				  		// ******************** if tf.factor_id is not degrading ****************************************
	 				  		if (P_isFactorDegrading[tf.factor_id]==0 ) { 
	 				  		
	 				  			//if tf.factor_id is time series factor
	 				  			for (var fnd2  in S_Factor_Id_TimeSeries){
	 		  						if(fnd2 ==tf.factor_id) {
	 		  							if(tf.index_type=="Int") {
					 						if(Opl.round(Opl.floatValue(P_assetFactor_statistical[ap.asset_id][fnd2][ap.time]))==tf.int_value){
					 							isExcludedBySubFilter = 1;
					 						}
					 					}
					 					else if (tf.index_type=="Range") {
					 						if(Opl.floatValue(P_assetFactor_statistical[ap.asset_id][fnd2][ap.time])>=tf.from_range && Opl.floatValue(P_assetFactor_statistical[ap.asset_id][fnd2][ap.time])<tf.to_range){
					 							isExcludedBySubFilter = 1;
					 						}
					 					}
	 		  						}
	 		  					}
	 				  		
	 				  			//if factor is raw factor
		 				  		if(tf.index_type=="String") { 
		 				  			if(P_assetFactor[ap.asset_id][tf.factor_id]==tf.string_value) {
		         						isExcludedBySubFilter = 1;	
		         						// writeln(ap, " is excluded, since factor is ", P_assetFactor[ap.asset_id][tf.factor_id]);
		         					}	
		       					}
		       					else if(tf.index_type=="Int") { 
			 				  		if((P_assetFactor[ap.asset_id][tf.factor_id]!="" ) &&
			 				  			(Opl.round(Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id]))==tf.int_value) ) {
			         					isExcludedBySubFilter = 1;
			         				}	
		       					}
		       					else if(tf.index_type=="Range") { 
			 				  		if( (P_assetFactor[ap.asset_id][tf.factor_id]!="" ) &&
			 				  			(Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id])>=tf.from_range 
			 				  				&& Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id])<tf.to_range) ){
			         					isExcludedBySubFilter = 1;
			         				}
		       					}
           					} // (P_isFactorDegrading[tf.factor_id]==0)	       					
	       					// ******************** if tf.factor_id is degrading ********************************************
	       					else {
	       						P_addAge = ap.time - P_fromYear;
	       					
	       						if(P_assetFactor[ap.asset_id][P_assetAgeFactorIndex] == ''){
					 				P_degradationAgeFrom = 0;
					 			}else{
					 				P_degradationAgeFrom = P_assetFactor[ap.asset_id][P_assetAgeFactorIndex];
					 			}
					 		  	P_degradationAgeTo = Opl.intValue(P_degradationAgeFrom) + P_addAge;
					 			P_cumDegradation = ( P_Degradation[tf.factor_id][P_degradationAgeTo] - P_Degradation[tf.factor_id][P_degradationAgeFrom] );
      						
      							if(tf.index_type=="Int") { 
			 				  		if( (P_assetFactor[ap.asset_id][tf.factor_id]!="" ) &&
			 				  			(Opl.round(Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id]))+P_cumDegradation==tf.int_value) ) {
			         					isExcludedBySubFilter = 1;
			         				}	
		       					}
		       					else if(tf.index_type=="Range") { 
			 				  		if((P_assetFactor[ap.asset_id][tf.factor_id]!="" ) &&
			 				  			(Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id])+P_cumDegradation>=tf.from_range 
			 				  				&& Opl.floatValue(P_assetFactor[ap.asset_id][tf.factor_id])+P_cumDegradation<tf.to_range)) {
			         					isExcludedBySubFilter = 1;
			         				}
		       					}	
      						
      						} // (P_isFactorDegrading[tf.factor_id]==1) {					 			
	       					
	       					
	       					if(isExcludedBySubFilter==0) {
	       						isExcludedByFilterId = 0;
	       						break;
	          				}       						
	       					else {
	       						isExcludedByFilterId = 1 ;
	           				}  
             			} // if(tf.driver_id==ap.driver_id && tf.treatment_id==ap.treatment_id)	           				     						
      				} // if(tfi==tf.filter_id)				  	 
   				}; // for(tf in ST_PS_Treatment_Filter) 				
 				
 				if(isExcludedByFilterId==1) { 
 					isExcluded = 1;
 					break;
   				}
   				   				 				
  			}; //  for(f in S_treatmentFilterId)			
 			if(isExcluded==0) ST_PS_Asset_Prescription_Filtered.add(ap);
 			else ST_PS_Asset_Prescription_Filtered_Out.add(ap);
 		}; // for(var ap in ST_PS_Asset_Prescription_Pre) 		
  	}; // execute CalcAssetPrescriptionFiltered 	   
 	
 	tuple T_PS_Asset_Prescription {
	  	string asset_class_id;
	  	string asset_id;
	  	int driver_id;
	  	int treatment_id;	
	  	string treatment_name;
	  	string treatment_description;  
	  	float treatment_cost;
		int service_life_extension;
		int service_life_improvement;
		string location_description;
		int time;
  	};
  	{T_PS_Asset_Prescription} ST_PS_Asset_Prescription = { 
  		<
  		P_assetClassId,
  		ap.asset_id,
  		ap.driver_id,
  		ap.treatment_id,
  		at.treatment_name,
  		at.treatment_description,
  		at.unit_cost*floatValue(P_assetFactor[ap.asset_id][P_assetLengthFactorIndex]),
  		at.service_life_extension,
  		at.service_life_improvement,
  		ap.location_description,
  		ap.time
  		>|
  		ap in ST_PS_Asset_Prescription_Filtered,
  		at in ST_PS_Asset_X_Treatment 
  		: 
  		ap.treatment_id==at.treatment_id
  	};
  	
// Output to CSV ==================================================================================
  	 
execute {  
	ST_PS_Asset_Class_Score;
	ST_PS_Asset_Prescription;
	ST_PS_Asset_Prescription_Filtered_Out;
	writeln("End Time : ",  new Date());
};  

/*
	execute OutputToCSVComplete {  
		var ofile = new IloOplOutputFile(".\\log\\assetScoreCalculationCompleted.csv");
		ofile.writeln(ST_PS_Execution_Parameters);
		ofile.writeln("End Time : ",  new Date());
		ofile.close();    	
	}; 

	execute OutputToCSV {  
		writeln("End CalcFactorScoreDegrading : ",  new Date());
		var ofile = new IloOplOutputFile(".\\CSV\\ST_PS_Asset_Factor_Score.csv");
	  	for(i in ST_PS_Asset_Factor_Score) {
	     	ofile.writeln(i.asset_class_id, ",",
					  	i.asset_id, ",",
					  	i.driver_id, ",",
					  	i.driver_name, ",",
					  	i.factor_id, ",",
					  	i.factor_name, ",",
					  	i.factor_value, ",",
					  	i.factor_score, ",",
					  	i.factor_weight, ",",
					  	i.weighted_factor_score, ",",
					  	i.location_description, ",",
					  	i.street_name, ",",
					  	i.app_asset_id, ",",
					  	i.time);	 	
	 	}
		ofile.close();    	
	}; 
*/  	 
  	 