#!/bin/sh
# 
# Licensed Materials - Property of IBM
#
# <AFBA_PID>
#
# (C) Copyright IBM Corp. <AFBA_YEAR> All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# 

CUR_DIR=$(cd -P -- "$(dirname -- "$0")" && pwd -P)

export CLASS_PATH=$CLASS_PATH:$CUR_DIR/ife_frwk_utils.jar
export MAIN_CLASS=com.ibm.ife.framework.common.utils.EncryptUtil

JAVA_HOME=`find / -name jre_* | grep InstallationManager/eclipse`

if [ $# = "3" ] 
	then
		$JAVA_HOME/jre/bin/java -cp $CLASS_PATH $MAIN_CLASS $1 $2 $3
else
	if [ $# = "1" ] 
	then
		$JAVA_HOME/jre/bin/java -cp $CLASS_PATH $MAIN_CLASS $1
	else
		echo "  Usage: ./encrypt.sh [properties file path] [property name] encryptType"
		echo "  or"
		echo "         ./encrypt.sh [decryption_value]"
		echo "Example: ./encrypt.sh test.properties PASSWORD aes ;Two types available base64 and aes"
		echo "Example: ./encrypt.sh {base64}UEFTU1dPUkQ="
		exit 1
	fi
fi
