##
# Licensed Materials - Property of IBM
#
# IBM Insights Foundation for Energy  5725-W39
#
# (C) Copyright IBM Corp. 2016  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
## 

#!/bin/bash

SOURCE="${BASH_SOURCE[0]}"
DIR="$( dirname "$SOURCE" )"
cd $DIR

if [ $# -ne 3 ]; then
        echo "Usage: $0 <score file path> <db2 username > <db2 password>"
        exit 1
fi

ah_cfp_score_path=$1
su - $2 -c "db2 connect to IFEDB user $2 using $3;

db2 \"call AHA.deleteAssetScores('Pole')\";

db2 load client from ${ah_cfp_score_path}/db_pole_network_risk_score.csv of del INSERT INTO SCORE.ASSET_SCORE;
db2 set integrity for SCORE.ASSET_SCORE immediate checked;

db2 connect reset;
db2 terminate;

"
