#!/bin/sh
scriptLocation=$(cd -P -- "$(dirname -- "$0")" && pwd -P)
#####################################################################
#Replace the following content with actual value
#####################################################################
modelerBatchPath=/usr/IBM/SPSS/ModelerBatch/18.0/
modelerServerPath=/opt/IBM/SPSS/ModelerServer/18.0
spssRootPassword=X6xjdJ5f
spss_serverName=mansoor1.pmq253qa.ibm.com
dbUserPassword=db2inst1


#########################################################
#Back up Grid engine cfg file...
#########################################################
/opt/IBM/energy/grid_engine/ife_aoms_core/scripts/grid_engine.sh stop
cp /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/grid_engine.cfg $scriptLocation/grid_engine.cfg.bk

tar zxvf $scriptLocation/Analysis/grid_engine/*.gz -C /opt/IBM/energy/grid_engine

dos2unix /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/grid_engine.cfg
dos2unix /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/call_asset_health_service.sh
chmod +x /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/*.sh
dos2unix /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/*.sh
dos2unix /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/utils/*.sh 
chmod +x /opt/IBM/energy/grid_engine/ife_aoms_core/scripts/utils/*.sh

#########################################################
#Deploy SPSS stream...
#########################################################

echo "Deploy SPSS stream......"
mkdir -p /opt/IBM/energy/AssetHealth
rm -rf /opt/IBM/energy/AssetHealth/SPSS_stream/stream
cp -rf $scriptLocation//Analysis/SPSS/SPSS_stream /opt/IBM/energy/AssetHealth
chmod -R 777 /opt/IBM/energy/AssetHealth
dos2unix /opt/IBM/energy/AssetHealth/SPSS_stream/script/*.*
#crontab /opt/IBM/energy/AssetHealth/SPSS_stream/script/cronTabFile.txt

dos2unix /opt/IBM/energy/AssetHealth/SPSS_stream/lib/*.sh
chmod +x /opt/IBM/energy/AssetHealth/SPSS_stream/lib/*.sh

#########################################################
#Update ah_params_config.cfg ...
#########################################################
#sed -i s#"poleTTargetModelTrainingOrPrediction=\(.*\)"#"poleTTargetModelTrainingOrPrediction=2"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/ah_params_config.cfg
#sed -i s#"poleTTargetModelFile=\(.*\)"#"poleTTargetModelFile=stream/Pole/TTARGET.gm"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/ah_params_config.cfg
  

#########################################################
#Update modelerServer.cfg ... still need to change and encrypt the password of root accroding to actual env 

#########################################################
sed -i s#"hostname=ife-ana.cn.ibm.com"#"hostname=$spss_serverName"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg
#sed -i s#"user=root"#"user=root"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg  
sed -i s#"password=pw4iow16"#"password=$spssRootPassword"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg
sed -i s#"modelerBatch=/opt/IBM/SPSS/ModelerBatch/17.0/"#"modelerBatch=$modelerBatchPath"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg

echo "Encrypt password in /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg"
/bin/sh /opt/IBM/energy/AssetHealth/SPSS_stream/lib/encrypt.sh  /opt/IBM/energy/AssetHealth/SPSS_stream/script/modelerServer.cfg password aes


#########################################################
#Update streamParams.cfg ...
#########################################################
sed -i s#"dspwd=pw4iow16"#"dspad=$dbUserPassword"#g  /opt/IBM/energy/AssetHealth/SPSS_stream/script/streamParams.cfg

echo "Encrypt dspwd in /opt/IBM/energy/AssetHealth/SPSS_stream/script/streamParams.cfg"
/bin/sh /opt/IBM/energy/AssetHealth/SPSS_stream/lib/encrypt.sh  /opt/IBM/energy/AssetHealth/SPSS_stream/script/streamParams.cfg dspwd aes
 

$modelerServerPath/modelersrv.sh stop
sleep 5
$modelerServerPath/modelersrv.sh start