#!/bin/sh
scriptBaseDir=$(cd -P -- "$(dirname -- "$0")" && pwd -P)
#############################################################################
#Replace the following content with actual value, provided some default value
#############################################################################
COGNOS_InstallLocation=/opt/ibm/cognos/analytics

db2_portNumber=50000
db2_password=db2inst1
db2_serverName=mansoor4.pmq253qa.ibm.com
db2_user=db2inst1

DISPATCH_URL=http://localhost:9300/p2pd/servlet/dispatch/ext

JVM_ARGS=""

# if https access of cognos is enabled then uncomment below lines, and change to correct parameters
#cognos_serverName=pmq253-bi.cn.ibm.com
#cognos_serverPort=9400
#DISPATCH_URL=https://${cognos_serverName}:${cognos_serverPort}/p2pd/servlet/dispatch/ext
#JVM_ARGS=" -Djavax.net.ssl.trustStore=/opt/ibm/cognos/analytics/wlp/usr/servers/ask_server/resources/security/cognos_ssl/cognos_sdk_ssl_keystore  -Djavax.net.ssl.trustStorePassword=cognos_sdk_ssl_passw0rd "
# if https access of cognos is enabled then uncomment above lines, and change to correct parameters

#################################################################################
db2_databaseName=IFEDB

JAVA_HOME=$COGNOS_InstallLocation
JAVA=${JAVA_HOME}/jre/bin/java

COGNOS_DB2_REMOTE_HOSTNAME=$db2_serverName
COGNOS_DB2_REMOTE_PORT=$db2_portNumber

COGNOS_ARCHIVE_NAME=IFEReport
COGNOS_ARCHIVE_PWD=123
COGNOS_DEPLOYMENT=IFEReport_Import
COGNOS_DS_NAME=IFEDS

DB_INSTANCE_USER=$db2_user
DB_PASSWORD=$db2_password
DB_NAME=$db2_databaseName

COGNOS_DB2_URL=jdbc:db2://$COGNOS_DB2_REMOTE_HOSTNAME:$COGNOS_DB2_REMOTE_PORT   
COGNOS_DEPLOYMENT_JAR=$scriptBaseDir/Cognos/cognos/distribution/CognosDeployment.jar
COGNOS_DEPLOYMENT_DIRECTORY=$COGNOS_InstallLocation/deployment/
Lib_DIR=$COGNOS_InstallLocation/webapps/p2pd/WEB-INF/lib

FILE_NAME=$scriptBaseDir/Cognos/cognos/IFEReport.zip 
ARCHIVE_NAME=$COGNOS_ARCHIVE_NAME
ARCHIVE_PWD=$COGNOS_ARCHIVE_PWD
DEPLOYMENT_NAME=$COGNOS_DEPLOYMENT


#####################################################################
#Deploy cognos report
#####################################################################

chmod +x $scriptBaseDir/Cognos/cognos/distribution/CognosDeployment.jar

# Build the CLASSPATH required
for jar in axis axisCrnpClient commons-discovery-0.2 commons-logging-1.1 log4j-1.2.17 jaxrpc wsdl4j-1.5.1;
 do
  CLASSPATH=$CLASSPATH:$Lib_DIR/$jar.jar
done

cp -v -f $FILE_NAME $COGNOS_InstallLocation/deployment/
chmod -R 775 $COGNOS_InstallLocation/deployment/$ARCHIVE_NAME*

$JAVA $JVM_ARGS -classpath $CLASSPATH:$scriptBaseDir/Cognos/cognos/distribution/CognosDeployment.jar cognos.ImportReports -a $ARCHIVE_NAME -i $ARCHIVE_PWD -d $DEPLOYMENT_NAME -g $DISPATCH_URL

cp -rf $scriptBaseDir/Cognos/cognos/images/*.png $COGNOS_InstallLocation/webcontent/images 