#!/bin/bash
# Amith: This is a first pass script from Haijing and is not tested.
# It should not be used until it is tested.

exit 0;

# This script packages SEP for use by application developers
# It takes these arguments:
# 1. the platform (g++64, g++, etc)
# 2. output directory where the package should be placed
# 3. package.conf file 
platform=$1
outdir=$2
pkgconf=$3

source $pkgconf

confdir=$outdir/config
datadir=$outdir/data
docdir=$outdir/doc
jdocdir=$docdir/Java
cdocdir=$docdir/C
libdir=$outdir/lib
clibdir=$libdir/C
clibstatdirplat=$clibdir/Statlibs/@_@${platform}_
clibshareddirplat=$clibdir/Sharedlibs/@_@${platform}_
cincludedir=$clibdir/Includes
jardir=$libdir/Java
streamsdir=$libdir/Streams
streamstksdir=$streamsdir/Toolkits
streamsappsdir=$streamsdir/Apps
scriptsdir=$outdir/scritps
srcdir=$outdir/src
streamstksdir=$srcdir/Streams/Toolkits
streamsappsdir=$srcdir/Streams/Apps
testdir=$outdir/test
webdir=$outdir/web/WebContent

rm -rf $outdir/*
mkdir $confdir
mkdir $datadir
mkdir $docdir
mkdir $jdocdir
mkdir $cdocdir
mkdir $libdir
mkdir $clibdir
mkdir -p $clibstatdirplat
mkdir -p $clibshareddirplat
mkdir $cincludedir
mkdir $jardir
mkdir $streamsdir
mkdir $scriptsdir
mkdir $srcdir
mkdir -p $streamstksdir
mkdir -p $streamsappsdir
mkdir $testdir
mkdir -p $webdir

cp $AOMS_BASE/README.md $outdir
cp $AOMS_BASE/package.conf $outdir
cp $AOMS_BASE/TODO.md $outdir

## ------------- Make Java package --------------
# Create JAR of AOMS Java packages
cd $AOMS_BASE/src/Java
jarfile=$jardir/$PKG_NAME-$PKG_VERSION-$PKG_RELEASE.jar
for f in $JPACKS
do
    if [ -f $jarfile ]
    then
        jar uf $jarfile `find com/ibm/aoms/$f -name "*.class"`
    else
        jar cf $jarfile `find com/ibm/aoms/$f -name "*.class"`
    fi
done
cd -

# Copy the external JARs
for j in $JEXTJARS
do
    cp -p $AOMS_BASE/lib/Java/$j $jardir
done

# Create the Javadoc
jdocinp=`echo $JPACKS |sed "s/\//./g" | awk -v pre="com.ibm.aoms." '{for (i=1;i<=NF;i++) printf "%s:",pre$i;}'`
javadoc -classpath $AOMS_BASE/lib/Java/*:$AOMS_BASE/src/Java -d $jdocdir -sourcepath $AOMS_BASE/src/Java -subpackages $jdocinp

## ------------- Make C package ----------------
# Copy over the archives and headers of AOMS libraries
for f in $CLIBS
do
    echo $f
    find $AOMS_BASE/src/C/Libs/$f -name "*$platform*.a" -exec cp {} $clibstatdirplat \;
    find $AOMS_BASE/src/C/Libs/$f -name "*.h" -exec cp {} $cincludedir \;
    find $AOMS_BASE/src/C/Libs/$f -name "*.hpp" -exec cp {} $cincludedir \;
done

# Copy over the external libraries and headers
for l in $CEXTLIBS
do
    cp -p $AOMS_BASE/lib/C/$l/Statlibs/@_@${platform}_/*.a $clibstatdirplat
    cp -p $AOMS_BASE/lib/C/$l/Sharedlibs/@_@${platform}_/*.so $clibshareddirplat
    cp -pr $AOMS_BASE/lib/C/$l/Includes/* $cincludedir
done

# Create documentation
doxyinp=`echo $CLIBS | awk -v pre="$AOMS_BASE/src/C/Libs/" '{for (i=1;i<=NF;i++) printf "%s ",pre$i;}'`
cd $outdir
doxygen -g
cat Doxyfile | awk -v outdir=$cdocdir '{ \
    if ($1 == "INPUT") print "INPUT = $(doxyinp)"; \
    else if ($1 == "PROJECT_NAME") print "PROJECT_NAME = AOMS"; \
    else if ($1 == "EXTRACT_ALL") print "EXTRACT_ALL = YES"; \
    else if ($1 == "RECURSIVE") print "RECURSIVE = YES"; \
    else if ($1 == "OUTPUT_DIRECTORY") print "OUTPUT_DIRECTORY = "outdir; \
    else if ($1 == "GENERATE_LATEX") print "GENERATE_LATEX = NO"; \
    else print;
    }' > Doxyfile.aoms
rm Doxyfile
doxygen Doxyfile.aoms
rm Doxyfile.aoms
cd -

## -------------- Make Streams pacakge -----------------
# Copy over Streams binary from src folder 
cd $AOMS_BASE/src/Streams/Apps
cp -pr * $streamsappsdir
cd $AOMS_BASE/src/Streams/Toolkits
cp -pr * $streamstksdir 
cd -

# Copy over external toolkits
for t in $STKS
do
    cp -pr $AOMS_BASE/lib/Streams/$t $streamsdir
done

# No Streams documentation generation yet

## -------------- Copy over web folder ---------------
if [ -d "$AOMS_BASE/web/WebContent/$PKG_NAME" ]; then
    cp -pr $AOMS_BASE/web/WebContent/$PKG_NAME $webdir
fi

## -------------- Copy Over other files --------------
cd $AOMS_BASE/config
cp -r * $confdir
cd $AOMS_BASE/data
cp -r * $datadir
cd $AOMS_BASE/scripts
cp -r * $scriptsdir
cd $AOMS_BASE/test
cp -r * $testdir

cd $AOMS_BASE/doc/
cp *.pdf $docdir
cd $AOMS_BASE/doc/Latex
mkdir $docdir/Latex
cp *.pdf $docdir/Latex
cp -r Figures $docdir/Latex



## -------------- Make final tarball -----------------
cd $outdir
tar cvfz $PKG_NAME.tgz *
#find . -mindepth 1 -maxdepth 1 -type d -exec rm -rf {} \;
cd -


