About
=====
This is an SEP Application/Package.

<Please add more information>


Application/Package directory structure
=======================================

|-- README.md                          : This
|-- INSTALL.md                         : Installation instructions
|-- TODO.md                            : Todo's for this application/package
|-- Makefile                           : Application/package make commands
|-- package.conf                       : Specification of pkg/application (version, dependancy etc)
|-- src/                               : All source code
|   |-- C/                             : Source code for C/C++
|   |   |-- Makefile                   : Makefile for C/C++
|   |   |-- AuxScripts/                : Dir for extra scripts
|   |   |-- Makefiles/!                : Core C Makefiles
|   |   |-- Progs/                     : C application program development folders
|   |   |-- Tests/                     : C regression test program development folders
|   |   |-- Libs/                      : C library-like development folders
|   |   |-- Specials/                  : Parent for addition C library-like development folders that need custom Makefiles
|   |   `-- Scripts/!                  : Scripts for running C builds
|   |--Java                            : Java source
|   |   |-- Makefile                   : Makefile for Java
|   |   |-- com/ibm/aoms/<pkg>/libs/   : Java library-like packages and classes
|   |   |-- com/ibm/aoms/<pkg>/progs/  : Java application program packages and classes
|   |   `-- com/ibm/aoms/<pkg>/tests/  : Java regression test program packages and classes
|   |-- Streams                        : Streams build dir
|   |   |-- Makefile                   : Makefile for Streams
|   |   |-- Makefiles/!                : Various Makefiles
|   |   |-- Toolkits/                  : Streams toolkit development folders
|   |   `-- Apps/                      : Streams application development folders
|   |-- OPL/                           : ILOG Cplex OPL model folders
|   |-- SPSSModeler/                   : SPSS Modeler model artifact and script folders
|   |-- SPSSStatistics/                : SPSS Statistics model artifact and Syntax folders
|   |-- SQL/                           : Contains folders with sql files
|   `-- Cognos/                        : Cognos Framework Manager report package .zip
|-- bin/                               : Application execution files
|-- lib/                               :
|   |-- C/                             : C external libs
|   |   |-- <extlib>/                  : External C library package
|   |   |   |-- Statlibs/              : 
|   |   |   |   `-- g++64_/*.a         : Static libs for package
|   |   |   |-- Sharedlibs/            : 
|   |   |   |   `-- g++64_/*.so*       : Shared libs for package
|   |   |   `-- Includes/              : Header files and folder for package
|   |   `-- <Other extlibs>            : Additional external packages. 
|   |-- Java/                          : .jar files for java
|   `-- Streams/                       : Libs for Streams
|       `-- <toolkit>/                 : External toolkit that is not in an aoms-init structure
|-- test/                              : Tests
|   |-- Scripts/!                      : Scripts for running tests
|   |-- Output/                        : Output of tests
|   `-- TestCases/                     : Directory tree holding regression test scripts
|       |-- <testgroup>                : A group of regression tests
|       |   |-- <testcase>             : A sub-group (case) of regression tests
|       |   |   |-- Scripts/           : Scripts that each run a regression test
|       |   |   |-- Inputs/            : Input data files and helper scripts used by the scripts in 'Scripts/'
|       |   |   `-- Golden/            : Golden output files for the regression tests
|       |   `-- <other testcases>
|       `-- <other testgroups>
|-- web/                               : Java web server code for WAS/WPS deployment. Only single web allowed. 
|   |-- WebContent/                    : Web source
|   |   |-- WEB-INF/              
|   |   |-- data/                      : Data used by the web application
|   |   |-- images/                    : Images used in the web application
|   |   |-- javascripts/               : Javascript files
|   |   |-- stylesheets/               : Stylesheet
|   |   `-- views/                     : Web pages, e.g. Java Server Page (JSP) files
|   `-- <Other java web dirs>          : Various other required 
|-- data/                              : Data for package/application
|-- scripts/                           : Scripts for package/application
|-- config/                            : Configuration for application
|   |-- env/<envscript>                : Script that sets application-specific environment vars
|   |-- Informix
|   |   |-- odbc.ini                   : ODBC config file used by components of the application
|   |   `-- sqlhosts                   : ODBC SQL hosts file used by components of the application
|   `-- Streams
|       `-- <connectionsxml>           : Connections XML file used for Streams DB toolkit operators
|-- doc/                               : Documentation for application
|   `-- Latex/                         : LaTex documentation
|       |-- Makefile                   : Makefile to build PDF from LaTex
|       `-- Figures/                   : Figures to be used in Latex document
|-- tmp/                               : tmp dir for application run
`-- log/                               : log files for application run
