# This is required to ensure make understands the top target.  Otherwise
# any rules added by the user as overrides will prevent the library from
# being built

.DEFAULT_GOAL := @_@$(AOMS_MAKE_PLATFORM)lib$(LIBRARY).a

-include local_overrides.mk

# This gathers all *.C and *.c and forms .o's for them
OBJS = $(patsubst %.cpp,@_@$(AOMS_MAKE_PLATFORM)%.o,$(wildcard *.cpp)) \
	$(patsubst %.C,@_@$(AOMS_MAKE_PLATFORM)%.o,$(wildcard *.C)) \
	$(patsubst %.c,@_@$(AOMS_MAKE_PLATFORM)%.o,$(wildcard *.c)) $(AOMS_MAKE_USER_OBJS) 
#BEAMS = $(patsubst %.o,%.beam,$(OBJS))
BEAMS = $(OBJS:.o=.beam)
NL_TMP := $(patsubst $(AOMS_BASE)/src/C/Libs/%/,%,$(wildcard $(AOMS_BASE)/src/C/Libs/*/))
UC_I   := -I $(AOMS_BASE)/src/C/Libs $(foreach lib, $(filter-out CVS,$(NL_TMP)), -I $(AOMS_BASE)/src/C/Libs/$(lib)/ )

ML_TMP  := $(patsubst $(AOMS_BASE)/lib/C/%/,%,$(wildcard $(AOMS_BASE)/lib/C/*/))
UC_I    := $(UC_I) $(foreach lib, $(filter-out CVS,$(ML_TMP)), -I $(AOMS_BASE)/lib/C/$(lib)/Includes/ )

# causes the implicit rules to be applied and library to be build, this is the default target
@_@$(AOMS_MAKE_PLATFORM)lib$(LIBRARY).a: $(OBJS)
	ar srv @_@$(AOMS_MAKE_PLATFORM)lib$(LIBRARY).a $(OBJS) 

include $(AOMS_BASE)/src/C/Makefiles/implicit.makefile

beam : $(BEAMS)

.PHONY: clean proper depend beam clean_beam

clean: clean_beam $(AOMS_MAKE_USER_CLEAN_TARGET)
	rm -f @_@$(AOMS_MAKE_PLATFORM)*.o 
	rm -f @_@$(AOMS_MAKE_PLATFORM)*.a
	rm -f @_@$(AOMS_MAKE_PLATFORM)DEPENDENCIES

proper: clean
	rm -f Makefile
	rm -f @_@*

depend: $(AOMS_MAKE_USER_DEPENDS)
	$(AOMS_MAKE_DEPEND)| sed 's/^.*\.o:/@_@$(AOMS_MAKE_PLATFORM)&/' > @_@$(AOMS_MAKE_PLATFORM)DEPENDENCIES

clean_beam:
	rm -f *.beam *.complaint
	rm -f $(BEAMS) *.stats *.complaint

-include @_@$(AOMS_MAKE_PLATFORM)DEPENDENCIES
