.SUFFIXES: .beam
# the global rules how to build object files and programs

##########################################################################
# Settings for BEAM 
# 
##########################################################################
AOMS_CPP_TCL=$(AOMS_BASE)/src/C/Scripts/compiler_cpp_config.tcl
AOMS_C_TCL=$(AOMS_BASE)/src/C/Scripts/compiler_c_config.tcl
AOMS_BEAM_COMPILER=/opt/IBM/beam/bin/beam_compile
AOMS_BEAM_CXXFLAGS=-I/usr/include/c++/4.1.2/ --beam::stats_file=$*.stats --beam::compiler=${AOMS_CPP_TCL} --beam::complaint_file=$*.complaint 
AOMS_BEAM_CFLAGS=-I/usr/include/c++/4.1.2/ --beam::stats_file=$*.stats --beam::compiler=${AOMS_C_TCL}  --beam::complaint_file=$*.complaint


# for C++ modules
@_@$(AOMS_MAKE_PLATFORM)%.o : %.cpp
	$(AOMS_MAKE_CXX)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) -c -o @_@$(AOMS_MAKE_PLATFORM)$*.o $<	
@_@$(AOMS_MAKE_PLATFORM)%.beam : %.cpp
	$(AOMS_BEAM_COMPILER)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) $(AOMS_BEAM_CXXFLAGS) -o './@_@$(AOMS_MAKE_PLATFORM)$*' -c $<

@_@$(AOMS_MAKE_PLATFORM)%.o : %.C
	$(AOMS_MAKE_CXX)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) -c -o @_@$(AOMS_MAKE_PLATFORM)$*.o  $<
@_@$(AOMS_MAKE_PLATFORM)%.beam : %.C
	$(AOMS_BEAM_COMPILER)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) $(AOMS_BEAM_CXXFLAGS) -o './@_@$(AOMS_MAKE_PLATFORM)$*' -c $<

# for C modules
@_@$(AOMS_MAKE_PLATFORM)%.o : %.c
	$(AOMS_MAKE_CC)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) -c -o @_@$(AOMS_MAKE_PLATFORM)$*.o $<
@_@$(AOMS_MAKE_PLATFORM)%.beam : %.c
	$(AOMS_BEAM_COMPILER)   $(UC_I) $(AOMS_MAKE_CFLAGS) $(AOMS_MAKE_USER_CFLAGS) $(AOMS_BEAM_CFLAGS) -o './@_@$(AOMS_MAKE_PLATFORM)$*' -c $<

# for programs
@_@$(AOMS_MAKE_PLATFORM)% : @_@$(AOMS_MAKE_PLATFORM)%.o
	$(AOMS_MAKE_LINK) $(UL_I) $(AOMS_MAKE_USER_LDFLAGS) -o @_@$(AOMS_MAKE_PLATFORM)$* $< $(AOMS_MAKE_LGSTART) $(U_LIBR) $(U_ELIBR) $(U_SLIBR) $(AOMS_MAKE_LGEND) $(AOMS_MAKE_LDFLAGS) -lm

# for lex
%.C : %.l
	$(AOMS_MAKE_LEXX) $<


# for bison
%.C : %.y
	$(AOMS_MAKE_BISON) $<
