#########################################################################
# set environment variables that specify the base programs
# The programs have to be in PATH.
#########################################################################
#export U_MAKE="gmake"
export AOMS_MAKE_CXX=g++
export AOMS_MAKE_CC=gcc
export AOMS_MAKE_LINK=g++
export AOMS_MAKE_LEXX=flex
export AOMS_MAKE_BISON=bison

#########################################################################
# Absolute path to the root of the build-platform diretory tree. 
#########################################################################
export AOMS_MAKE_BASE="$AOMS_BASE/src/C"

#########################################################################
# Set prefix for created files indicating platform.
#########################################################################
export AOMS_MAKE_PLATFORM="g++64_"

#########################################################################
# Set up basic compile, i.e. 64-bit or not, address space sizes,
# traceback table and toc etc.
# These are things that are shared between the different compile modes 
# (e.g. debug, optimized or for profiling). The compile modes are 
# controlled by the user on the outside via 'AOMS_MAKE_USER_CFLAGS'.
#########################################################################
OPLCFLAGS=" -DIL_STD -DILOUSEMT "
INFXLFLAGS=" -lcrypt"
export AOMS_MAKE_CFLAGS="-fPIC -m64 -D_LINUX -D_REENTRANT -D_64BIT -DEXCLUDE_FOR_CDL_DEMO -Wno-deprecated ${OPLCFLAGS}"
export AOMS_MAKE_LDFLAGS="-rdynamic -lXt -L/usr/X11R6/lib64/ -lX11 -lm -lpthread -lrt ${INFXLFLAGS}"
export AOMS_MAKE_LGSTART=" -Xlinker --start-group "
export AOMS_MAKE_LGEND=" -Xlinker --end-group "

##########################################################################
# Command to compute dependencies
##########################################################################
export AOMS_MAKE_DEPEND='g++ -Wno-deprecated -E -MM $(UC_I) *.[Cc] *.cpp *.y *.l '

##########################################################################
# command to make a shared library first argument is the output, 
# then the object files and libraries
##########################################################################
export AOMS_MAKE_SHARED_LIBS="g++ -shared -o "


##########################################################################
# Flags user can override to control optimization and debug options
# for compiler and linker.
##########################################################################
# export USERCFLAGS="-g -fno-omit-frame-pointer '-DCOMPLEX=std::complex<double>'"${OPLFLAGS}
# export USERLFLAGS="-g -lgfortran -lpthread -lrt -llapack -rdynamic ${INFXLFLAGS}"
export AOMS_MAKE_USER_CFLAGS="-g -fno-omit-frame-pointer "
export AOMS_MAKE_USER_LDFLAGS="-g "
