
#########################################################################
# set environment variables that specify the base programs
# The programs have to be in PATH.
#########################################################################
#export U_MAKE="gmake"
export AOMS_MAKE_CXX=xlC
export AOMS_MAKE_CC=xlc
export AOMS_MAKE_LINK=xlC
export AOMS_MAKE_LEXX=flex
export AOMS_MAKE_BISON=bison

export OBJECT_MODE=64
#########################################################################
# Absolute path to the root of the build-platform diretory tree. 
#########################################################################
export AOMS_MAKE_BASE="$AOMS_BASE/src/C"

#########################################################################
# Set prefix for created files indicating platform.
#########################################################################
export AOMS_MAKE_PLATFORM="xlc64_"

#########################################################################
# Set up basic compile, i.e. 64-bit or not, address space sizes,
# traceback table and toc etc.
# These are things that are shared between the different compile modes 
# (e.g. debug, optimized or for profiling). The compile modes are 
# controlled by the user on the outside via 'AOMS_MAKE_USER_CFLAGS'.
#########################################################################
export AOMS_MAKE_CFLAGS="-q64 -qnotempinc -qtbtable=full -qmaxmem=-1 -qspill=2000 -D_REENTRANT -D_64BIT -D_AIX"
export AOMS_MAKE_LDFLAGS="-bD:256000000000 -bS:256000000000 -lXt -L/usr/X11R6/lib64/ -lX11 -lm "
export AOMS_MAKE_LGSTART="  "
export AOMS_MAKE_LGEND="  "

##########################################################################
# Command to compute dependencies
##########################################################################
# export AOMS_MAKE_DEPEND='for V in *.[Cc] *.cpp *.y *.l; do xlC -E -M  $(UC_I) $$V -MF@_@$(AOMS_MAKE_PLATFORM).d > /dev/null; cat @_@$(AOMS_MAKE_PLATFORM).d; rm -f @_@$(AOMS_MAKE_PLATFORM).d;   done '
export AOMS_MAKE_DEPEND='g++ -Wno-deprecated -E -MM $(UC_I) *.[Cc] *.cpp *.y *.l '

##########################################################################
# command to make a shared library first argument is the output, 
# then the object files and libraries
##########################################################################
export AOMS_MAKE_SHARED_LIBS="xlC -G -o "
# export AOMS_MAKE_SHARED_LIBS="xlC -qmkshrobj -o "

##########################################################################
# Flags user can override to control optimization and debug options
# for compiler and linker.
##########################################################################
export AOMS_MAKE_USER_CFLAGS="-g"
export AOMS_MAKE_USER_LDFLAGS="-g -lpthread"
