#!/bin/bash

##
# Licensed Materials - Property of IBM
#
# IBM Insights Foundation for Energy  5725-W39
#
# (C) Copyright IBM Corp. 2015  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
## 

# To set up the env and build the package in RHEL 6.*
# Usage: build_grid_engine <full-root-path>

SOURCE="${BASH_SOURCE[0]}"
DIR="$( dirname "$SOURCE" )"

cd $DIR/..

export AOMS_ENV_ROOT="$PWD"
export PATH="$PATH:$AOMS_ENV_ROOT/bin"

#
# To ensure we truly don't count on STREAMS being installed
# 
export STREAMS_INSTALL=
export STREAMS_DEFAULT_IID=

source "$AOMS_ENV_ROOT/scripts/aomsprofile.sh"

function build() {
echo "====================================="
echo "Starting build package..."
echo "====================================="
	aoms_package=aoms-grid-service
	echo "Building $aoms_package..."
	cd $AOMS_ENV_ROOT/src/$aoms_package
	aoms-builder devdepend g
	source aoms-make-setupenv "$PWD" --force
	aoms-make setup
	aoms-make cleanbuild
	
	aoms_package=aoms-cfp
	echo "Building $aoms_package..."
	cd $AOMS_ENV_ROOT/src/$aoms_package
	aoms-builder devdepend g
	source aoms-make-setupenv "$PWD" --force
	aoms-make setup
	aoms-make cleanbuild
	
	if [ $? -ne 0 ]; then
		echo "====================================="
		echo "Failed to build package"
		echo "====================================="
		exit 1
	else
		echo "====================================="
		echo "Finish build package"
		echo "====================================="
	fi	
}

#
# main function
#
$AOMS_ENV_ROOT/scripts/build_setup.sh
build
$AOMS_ENV_ROOT/scripts/dist_grid_engine.sh $AOMS_ENV_ROOT
