#!/bin/bash

##
# Licensed Materials - Property of IBM
#
# IBM Insights Foundation for Energy  5725-W39
#
# (C) Copyright IBM Corp. 2015  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
## 

# Use current directory
AOMS_WORKING_DIR=`pwd -P;`
export AOMS_WORKING_DIR
echo " Working directory is ${AOMS_WORKING_DIR}"
# Install aoms-env in the default location or in the location specified by AOMS_ENV_ROOT
if [ -z "${AOMS_ENV_ROOT}" ]; then
   echo " AOMS_ENV_ROOT is not defined. Nothing is done."
   echo " Set the AOMS_ENV_ROOT variable, and add $AOMS_ENV_ROOT to PATH before running this script."
   exit;
fi

cd ${AOMS_WORKING_DIR}

source aoms-env-var

cd "$AOMS_ENV_PKGS"
echo "Working directory = $PWD"
for d in `find . -mindepth 1 -maxdepth 1 -type d`
do
		 echo "Processing $d"
    cd "$d"
    make proper 
    make setup 
    cd -
done

#cd "$AOMS_ENV_SRC"
#echo "Working directory = $PWD"
#for d in `find . -mindepth 1 -maxdepth 1 -type d`
#do
#		 echo "Processing $d"
#    cd "$d"
#    make proper 
#    make setup 
#    cd -
#done
