#!/bin/bash

##
# Licensed Materials - Property of IBM
#
# IBM Insights Foundation for Energy  5725-W39
#
# (C) Copyright IBM Corp. 2015  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
## 

SOURCE="${BASH_SOURCE[0]}"
DIR="$( dirname "$SOURCE" )"

CURR_DIR="$PWD"

cd $DIR/../..
[ "$AOMS_ENV_ROOT" ] || AOMS_ENV_ROOT="$PWD" 

cd ${CURR_DIR}

DECODING=
while getopts 'd' OPTION
do
  case $OPTION in
  d)	DECODING="true";;
  ?)	echo "Usage: $0 [-d] <property_file> <property_name>"
  		exit 1;;
  esac
done
shift $(($OPTIND - 1))

if [ "$#" -ne 2 ]
then
	echo "Usage: $0 <property_file> <property_name>"
	exit 1
else
	PROP_FILE=$1
	PROP_NAME=$2
fi

CLASSPATH=$AOMS_ENV_ROOT/src/aoms-utl/src/Java
MAIN_CLASS=com.ibm.aoms.aomsutl.EncryptUtil

java -cp $CLASSPATH $MAIN_CLASS $PROP_FILE $PROP_NAME $DECODING
