############################################################
# Invocation of beam_configure:
#
#   '/opt/IBM/beam-3.6.1/bin/beam_configure' '--java' '/opt/ibm/java-x86_64-70/bin/javac'
#
# Location of compiler:
#
#   /opt/ibm/java-x86_64-70/bin/javac
#
############################################################
#
# This is BEAM configuration file that describes a Java
# compilation environment. This was generated with beam_configure
# version "4.0".
#
# This information will help BEAM emulate this compiler's
# Java language level, default classpath, and encoding
# so that BEAM can compile the same source code that the
# original compiler could compile.
#
# The file format is Tcl, so basic Tcl knowledge may be beneficial
# for anything more than the simplest of modifications.
# 
# A quick Tcl primer:
# - Lines starting with "#" or ";#" are comments
# - Things inside balanced curly braces are literal strings {one string literal}
# - Things in square brackets that aren't in curly braces are function calls,
#   and will be expanded inline automatically. This causes the most problems in
#   double-quoted strings: "this is a function call: [some_func]"
#
# This file contains these sections:
#
# 1) Source language dialect
# 2) Default Endorsed Directories
# 3) Default Boot Classpath
# 4) Default Extension Directories
# 5) Default Classpath
#
# Each section has variables that help configure BEAM. They should
# each be commented well. For additional documentation, please
# refer to the local documentation in the install point.
#
# Note that the order of the sections is not important,
# and variables may be set in any order.
#
# All variables are prefixed with name that corresponds to
# which language this configuration is for.
#
# For Java compilers, the prefix is "beam::compiler::java"
#
############################################################

### This is the version of beam_configure that generated this
### configuration file.
  
set beam::compiler::java::generated_by_beam_configure "4.0"


### This tells BEAM which pre-canned settings to load.
### BEAM comes with some function attributes and argument
### mappers for Sun Javac and IBM Javac.
###
### If unsure, set to 'default'.

# set beam::compiler::java::cc "sun_javac"
# set beam::compiler::java::cc "ibm_javac"

set beam::compiler::java::cc "javac"



############################################################
# Section 1: Source language dialect
############################################################
  
### The language_source_level variable selects among the available
### dialects of Java.

# set beam::compiler::java::language_source_level "1.3"
# set beam::compiler::java::language_source_level "1.4"
# set beam::compiler::java::language_source_level "1.5"

set beam::compiler::java::language_source_level "1.7"



### The encoding of the Java source files. This should be
### the same as the "file.encoding" System property of
### your Java Virtual Machine when run with no options.

# set beam::compiler::java::language_encoding {ANSI_X3.4-1968}

set beam::compiler::java::language_encoding "UTF-8"


  
############################################################
# Section 2: Default Endorsed Directories
############################################################

### The system_endorsed_dirs variable is a list of entries
### that will be used for the initial endorsed path. The
### endorsed path is a list of directories where Java
### Endorsed Standards live. Any jar file or zip file
### in these directories will be placed in the classpath
### before the boot classpath entries.
###
### This should be the same as the "java.endorsed.dirs"
### System property of your Java Virtual Machine when run
### with no cross-compilation options.

# lappend beam::compiler::java::system_endorsed_dirs {/path/to/jre/lib/endorsed}

lappend beam::compiler::java::system_endorsed_dirs {/opt/ibm/java-x86_64-70/jre/lib/endorsed}



############################################################
# Section 3: Default Boot Classpath
############################################################

### The system_boot_classpath variable is a list of entries
### that will be used for the initial boot classpath. These
### entries normally contain jar files that come with the
### java compiler itself, and contain the basic Java classes
### like java.lang.Object.
###
### This should be the same as the "sun.boot.class.path"
### System property of your Java Virtual Machine when
### run with no cross-compilation options.
  
# lappend beam::compiler::java::system_boot_classpath {/path/to/jre/lib/rt.jar}
# lappend beam::compiler::java::system_boot_classpath {/path/to/jre/lib/i18n.jar}
# lappend beam::compiler::java::system_boot_classpath {/path/to/jre/lib/jce.jar}

lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/amd64/compressedrefs/jclSC170/vm.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/se-service.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/math.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/jlm.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmorb.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmorbapi.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmcfw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmpkcs.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmcertpathfw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmjgssfw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmjssefw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmsaslfw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmjcefw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmjgssprovider.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmjsseprovider2.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/ibmcertpathprovider.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/xmldsigfw.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/xml.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/charsets.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/resources.jar}
lappend beam::compiler::java::system_boot_classpath {/opt/ibm/java-x86_64-70/jre/lib/rt.jar}



############################################################
# Section 4: Default Extension Directories
############################################################

### The system_ext_dirs variable is a list of entries that will
### be used for the initial extension path. The extension
### path is a list of directories where Java Extensions live.
### Any jar file or zip file in these directories will be placed
### in the classpath before the user directories.
###
### This should be the same as the "java.ext.dirs" System
### property of your Java Virtual Machine when run
### with no cross-compilation options.

# lappend beam::compiler::java::system_ext_dirs {/path/to/jre/lib/ext}

lappend beam::compiler::java::system_ext_dirs {/opt/ibm/java-x86_64-70/jre/lib/ext}

  

############################################################
# Section 5: Default Classpath
############################################################

### The system_classpath variable is a list of entries
### that will be used as the default classpath if no
### option is given on the command-line to override it.
### As per the Java documentation, it should default to
### the value of the environment variable $CLASSPATH.
### If the system_classpath variable ends up empty
### after BEAM has parsed all command-line arguments,
### "." will be used as the system_classpath.

if { [::info exists ::env(CLASSPATH)] } {
  set beam::compiler::java::system_classpath [split $::env(CLASSPATH) $::beam::pathsep]
}

